#!/bin/csh -f

if ($# < 2) then
  echo "Usage: $0 WDNproblem RunID_*_P.txt [RunID] [sampleSetSize] [RunID_*_P_robust.txt]"
  exit
endif

set popFile = $2

# Setup for robustness evaluation
if ($# > 2) then
  if ($1 == "T") then
    set WDNproblem = "TwoLoop"
  else if ($1 == "H") then
    set WDNproblem = "Hanoi"
  else if ($1 == "N") then
    set WDNproblem = "NewYorkCity"
  endif  

  # Perform robustness evaluation
  ./MOEA $WDNproblem.inp $2 $3 $4

  set popFile = $5
endif

set hvDir = "mies/hv-1.3svn152-src" 
set hv = "$hvDir/hv"

make -C $hvDir march=athlon-xp > /dev/null
sleep 5 # Omit "Device or resource busy" message

rm -f normalized.out
rm -f original.out

perl normalize.pl $1 $popFile 

$hv -r "1.0000001 1.0000001 1.0000001" normalized.out

