#!/usr/bin/perl

die "Usage: $0 WDNproblem RunID_*_P.txt\n" if ($#ARGV < 0);

@IdealTP = ();
@BoundTP = ();

if ($ARGV[0] eq "T")
{
  $IdealTP[0] = 16000;
  $IdealTP[1] = 1;
  $IdealTP[2] = 8;

  $BoundTP[0] = 4.4e+06;
  $BoundTP[1] = 0;
  $BoundTP[2] = 1;
}
elsif ($ARGV[0] eq "H")
{
  $IdealTP[0] = 1.80268e+06; 
  $IdealTP[1] = 1;
  $IdealTP[2] = 34;

  $BoundTP[0] = 1.09698e+07;
  $BoundTP[1] = 0;
  $BoundTP[2] = 1;
}
elsif ($ARGV[0] eq "N")
{
  $IdealTP[0] = 0;
  $IdealTP[1] = 1;
  $IdealTP[2] = 42;

  $BoundTP[0] = 2.94103e+08;
  $BoundTP[1] = 0;
  $BoundTP[2] = 1;
}
else
{
  die "Possible values for WDNproblem: T (TwoLoop), Hanoi (Hanoi), N (NewYorkCity)\n";
}

open(FILE, "<$ARGV[1]") || die "Could not open file \"$ARGV[1]\"!\n";
open(NORM, ">>normalized.out");
open(ORIG, ">>original.out");

while (<FILE>) 
{
  if ($_ ne "\n")
  {
    $_ =~ /([e\+\-\.\d]+)\s+([e\+\-\.\d]+)\s+([e\+\-\.\d]+)\s+/x; 

    @F = ($1, $2, $3);
    print ORIG "$1 $2 $3\n";

    for ($i = 0; $i < 3; $i++)
    {
      $scale = $BoundTP[$i] - $IdealTP[$i];
      $F[$i] = ($F[$i] - $IdealTP[$i]) / $scale; 
    }

    print NORM "$F[0] $F[1] $F[2]\n";
    undef (@F);
  }
}

close(NORM);
close(ORIG);
close(FILE);




