/* Test problem definitions */

# include <stdio.h>
# include <stdlib.h>
# include <math.h>

# include "global.h"
# include "rand.h"

/* # define SCH1 */
/* # define SCH2 */
/* # define FON */
/* # define KUR */
/* # define POL */
/* # define VNT */
/* # define ZDT1 */
/* # define ZDT2 */
/* # define ZDT3 */
/* # define ZDT4 */
/* # define ZDT5 */
/* # define ZDT6 */
/* # define BNH */
/* # define OSY */
/* # define SRN */
/* # define TNK */
/* # define CTP1 */
/* # define CTP2 */
/* # define CTP3 */
/* # define CTP4 */
/* # define CTP5 */
/* # define CTP6 */
/* # define CTP7 */
/* # define CTP8 */
# define EMM 

/*  Test problem SCH1
    # of real variables = 1
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */
void sch1 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    obj[0] = pow(xreal[0],2.0);
    obj[1] = pow((xreal[0]-2.0),2.0);
    return;
}
#ifdef SCH1
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &sch1; /* inserted: ereehuis */
#endif

/*  Test problem SCH2
    # of real variables = 1
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */
void sch2 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    if (xreal[0]<=1.0)
    {
        obj[0] = -xreal[0];
        obj[1] = pow((xreal[0]-5.0),2.0);
        return;
    }
    if (xreal[0]<=3.0)
    {
        obj[0] = xreal[0]-2.0;
        obj[1] = pow((xreal[0]-5.0),2.0);
        return;
    }
    if (xreal[0]<=4.0)
    {
        obj[0] = 4.0-xreal[0];
        obj[1] = pow((xreal[0]-5.0),2.0);
        return;
    }
    obj[0] = xreal[0]-4.0;
    obj[1] = pow((xreal[0]-5.0),2.0);
    return;
}
#ifdef SCH2
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &sch2; /* inserted: ereehuis */
#endif

/*  Test problem FON
    # of real variables = n
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */
void fon (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double s1, s2;
    int i;
    s1 = s2 = 0.0;
    for (i=0; i<nreal; i++)
    {
        s1 += pow((xreal[i]-(1.0/sqrt((double)nreal))),2.0);
        s2 += pow((xreal[i]+(1.0/sqrt((double)nreal))),2.0);
    }
    obj[0] = 1.0 - exp(-s1);
    obj[1] = 1.0 - exp(-s2);
    return;
}
#ifdef FON
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &fon; /* inserted: ereehuis */
#endif

/*  Test problem KUR
    # of real variables = 3
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */
void kur (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    int i;
    double res1, res2;
    res1 = -0.2*sqrt((xreal[0]*xreal[0]) + (xreal[1]*xreal[1]));
    res2 = -0.2*sqrt((xreal[1]*xreal[1]) + (xreal[2]*xreal[2]));
    obj[0] = -10.0*( exp(res1) + exp(res2));
    obj[1] = 0.0;
    for (i=0; i<3; i++)
    {
        obj[1] += pow(fabs(xreal[i]),0.8) + 5.0*sin(pow(xreal[i],3.0));
    }
    return;
}
#ifdef KUR
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &kur; /* inserted: ereehuis */
#endif

/*  Test problem POL
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */
void pol (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double a1, a2, b1, b2;
    a1 = 0.5*sin(1.0) - 2.0*cos(1.0) + sin(2.0) - 1.5*cos(2.0);
    a2 = 1.5*sin(1.0) - cos(1.0) + 2.0*sin(2.0) - 0.5*cos(2.0);
    b1 = 0.5*sin(xreal[0]) - 2.0*cos(xreal[0]) + sin(xreal[1]) - 1.5*cos(xreal[1]);
    b2 = 1.5*sin(xreal[0]) - cos(xreal[0]) + 2.0*sin(xreal[1]) - 0.5*cos(xreal[1]);
    obj[0] = 1.0 + pow((a1-b1),2.0) + pow((a2-b2),2.0);
    obj[1] = pow((xreal[0]+3.0),2.0) + pow((xreal[1]+1.0),2.0);
    return;
}
#ifdef POL
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &pol; /* inserted: ereehuis */
#endif

/*  Test problem VNT
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 3
    # of constraints = 0
    */
void vnt (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    obj[0] = 0.5*(xreal[0]*xreal[0] + xreal[1]*xreal[1]) + sin(xreal[0]*xreal[0] + xreal[1]*xreal[1]);
    obj[1] = (pow((3.0*xreal[0] - 2.0*xreal[1] + 4.0),2.0))/8.0 + (pow((xreal[0]-xreal[1]+1.0),2.0))/27.0 + 15.0;
    obj[2] = 1.0/(xreal[0]*xreal[0] + xreal[1]*xreal[1] + 1.0) - 1.1*exp(-(xreal[0]*xreal[0] + xreal[1]*xreal[1]));
    return;
}
#ifdef VNT
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &vnt; /* inserted: ereehuis */
#endif

/*  Test problem ZDT1
    # of real variables = 30
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */
void zdt1 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double f1, f2, g, h;
    int i;
    f1 = xreal[0];
    g = 0.0;
    for (i=1; i<30; i++)
    {
        g += xreal[i];
    }
    g = 9.0*g/29.0;
    g += 1.0;
    h = 1.0 - sqrt(f1/g);
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#ifdef ZDT1
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &zdt1; /* inserted: ereehuis */
#endif

/*  Test problem ZDT2
    # of real variables = 30
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */
void zdt2 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double f1, f2, g, h;
    int i;
    f1 = xreal[0];
    g = 0.0;
    for (i=1; i<30; i++)
    {
        g += xreal[i];
    }
    g = 9.0*g/29.0;
    g += 1.0;
    h = 1.0 - pow((f1/g),2.0);
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#ifdef ZDT2
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &zdt2; /* inserted: ereehuis */
#endif

/*  Test problem ZDT3
    # of real variables = 30
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */
void zdt3 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double f1, f2, g, h;
    int i;
    f1 = xreal[0];
    g = 0.0;
    for (i=1; i<30; i++)
    {
        g += xreal[i];
    }
    g = 9.0*g/29.0;
    g += 1.0;
    h = 1.0 - sqrt(f1/g) - (f1/g)*sin(10.0*PI*f1);
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#ifdef ZDT3
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &zdt3; /* inserted: ereehuis */
#endif

/*  Test problem ZDT4
    # of real variables = 10
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */
void zdt4 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double f1, f2, g, h;
    int i;
    f1 = xreal[0];
    g = 0.0;
    for (i=1; i<10; i++)
    {
        g += xreal[i]*xreal[i] - 10.0*cos(4.0*PI*xreal[i]);
    }
    g += 91.0;
    h = 1.0 - sqrt(f1/g);
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#ifdef ZDT4
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &zdt4; /* inserted: ereehuis */
#endif

/*  Test problem ZDT5
    # of real variables = 0
    # of bin variables = 11
    # of bits for binvar1 = 30
    # of bits for binvar2-11 = 5
    # of objectives = 2
    # of constraints = 0
    */
void zdt5 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    int i, j;
    int u[11];
    int v[11];
    double f1, f2, g, h;
    for (i=0; i<11; i++)
    {
        u[i] = 0;
    }
    for (j=0; j<30; j++)
    {
        if (gene[0][j] == 1)
        {
            u[0]++;
        }
    }
    for (i=1; i<11; i++)
    {
        for (j=0; j<4; j++)
        {
            if (gene[i][j] == 1)
            {
                u[i]++;
            }
        }
    }
    f1 = 1.0 + u[0];
    for (i=1; i<11; i++)
    {
        if (u[i] < 5)
        {
            v[i] = 2 + u[i];
        }
        else
        {
            v[i] = 1;
        }
    }
    g = 0;
    for (i=1; i<11; i++)
    {
        g += v[i];
    }
    h = 1.0/f1;
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#ifdef ZDT5
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &zdt5; /* inserted: ereehuis */
#endif

/*  Test problem ZDT6
    # of real variables = 10
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 0
    */
void zdt6 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double f1, f2, g, h;
    int i;
    f1 = 1.0 - (exp(-4.0*xreal[0]))*pow((sin(4.0*PI*xreal[0])),6.0);
    g = 0.0;
    for (i=1; i<10; i++)
    {
        g += xreal[i];
    }
    g = g/9.0;
    g = pow(g,0.25);
    g = 1.0 + 9.0*g;
    h = 1.0 - pow((f1/g),2.0);
    f2 = g*h;
    obj[0] = f1;
    obj[1] = f2;
    return;
}
#ifdef ZDT6
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &zdt6; /* inserted: ereehuis */
#endif

/*  Test problem BNH
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 2
    */
void bnh (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    obj[0] = 4.0*(xreal[0]*xreal[0] + xreal[1]*xreal[1]);
    obj[1] = pow((xreal[0]-5.0),2.0) + pow((xreal[1]-5.0),2.0);
    constr[0] = 1.0 - (pow((xreal[0]-5.0),2.0) + xreal[1]*xreal[1])/25.0;
    constr[1] = (pow((xreal[0]-8.0),2.0) + pow((xreal[1]+3.0),2.0))/7.7 - 1.0;
    return;
}
#ifdef BNH
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &bnh; /* inserted: ereehuis */
#endif

/*  Test problem OSY
    # of real variables = 6
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 6
    */
void osy (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    obj[0] = -(25.0*pow((xreal[0]-2.0),2.0) + pow((xreal[1]-2.0),2.0) + pow((xreal[2]-1.0),2.0) + pow((xreal[3]-4.0),2.0) + pow((xreal[4]-1.0),2.0));
    obj[1] = xreal[0]*xreal[0] +  xreal[1]*xreal[1] + xreal[2]*xreal[2] + xreal[3]*xreal[3] + xreal[4]*xreal[4] + xreal[5]*xreal[5];
    constr[0] = (xreal[0]+xreal[1])/2.0 - 1.0;
    constr[1] = 1.0 - (xreal[0]+xreal[1])/6.0;
    constr[2] = 1.0 - xreal[1]/2.0 + xreal[0]/2.0;
    constr[3] = 1.0 - xreal[0]/2.0 + 3.0*xreal[1]/2.0;
    constr[4] = 1.0 - (pow((xreal[2]-3.0),2.0))/4.0 - xreal[3]/4.0;
    constr[5] = (pow((xreal[4]-3.0),2.0))/4.0 + xreal[5]/4.0 - 1.0;
    return;
}
#ifdef OSY
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &osy; /* inserted: ereehuis */
#endif

/*  Test problem SRN
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 2
    */
void srn (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    obj[0] = 2.0 + pow((xreal[0]-2.0),2.0) + pow((xreal[1]-1.0),2.0);
    obj[1] = 9.0*xreal[0] - pow((xreal[1]-1.0),2.0);
    constr[0] = 1.0 - (pow(xreal[0],2.0) + pow(xreal[1],2.0))/225.0;
    constr[1] = 3.0*xreal[1]/10.0 - xreal[0]/10.0 - 1.0;
    return;
}
#ifdef SRN
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &srn; /* inserted: ereehuis */
#endif

/*  Test problem TNK
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 2
    */
void tnk (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    obj[0] = xreal[0];
    obj[1] = xreal[1];
    if (xreal[1] == 0.0)
    {
        constr[0] = -1.0;
    }
    else
    {
        constr[0] = xreal[0]*xreal[0] + xreal[1]*xreal[1] - 0.1*cos(16.0*atan(xreal[0]/xreal[1])) - 1.0;
    }
    constr[1] = 1.0 - 2.0*pow((xreal[0]-0.5),2.0) + 2.0*pow((xreal[1]-0.5),2.0);
    return;
}
#ifdef TNK
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &tnk; /* inserted: ereehuis */
#endif

/*  Test problem CTP1
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 2
    */
void ctp1 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double g;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*exp(-obj[0]/g);
    constr[0] = obj[1]/(0.858*exp(-0.541*obj[0]))-1.0;
    constr[1] = obj[1]/(0.728*exp(-0.295*obj[0]))-1.0;
    return;
}
#ifdef CTP1
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &ctp1; /* inserted: ereehuis */
#endif

/*  Test problem CTP2
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 1
    */
void ctp2 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    theta = -0.2*PI;
    a = 0.2;
    b = 10.0;
    c = 1.0;
    d = 6.0;
    e = 1.0;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    return;
}
#ifdef CTP2
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &ctp2; /* inserted: ereehuis */
#endif

/*  Test problem CTP3
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 1
    */
void ctp3 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    theta = -0.2*PI;
    a = 0.1;
    b = 10.0;
    c = 1.0;
    d = 0.5;
    e = 1.0;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    return;
}
#ifdef CTP3
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &ctp3; /* inserted: ereehuis */
#endif

/*  Test problem CTP4
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 1
    */
void ctp4 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    theta = -0.2*PI;
    a = 0.75;
    b = 10.0;
    c = 1.0;
    d = 0.5;
    e = 1.0;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    return;
}
#ifdef CTP4
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &ctp4; /* inserted: ereehuis */
#endif

/*  Test problem CTP5
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 1
    */
void ctp5 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    theta = -0.2*PI;
    a = 0.1;
    b = 10.0;
    c = 2.0;
    d = 0.5;
    e = 1.0;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    return;
}
#ifdef CTP5
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &ctp5; /* inserted: ereehuis */
#endif

/*  Test problem CTP6
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 1
    */
void ctp6 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    theta = 0.1*PI;
    a = 40.0;
    b = 0.5;
    c = 1.0;
    d = 2.0;
    e = -2.0;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    return;
}
#ifdef CTP6
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &ctp6; /* inserted: ereehuis */
#endif

/*  Test problem CTP7
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 1
    */
void ctp7 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    theta = -0.05*PI;
    a = 40.0;
    b = 5.0;
    c = 1.0;
    d = 6.0;
    e = 0.0;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    return;
}
#ifdef CTP7
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &ctp7; /* inserted: ereehuis */
#endif

/*  Test problem CTP8
    # of real variables = 2
    # of bin variables = 0
    # of objectives = 2
    # of constraints = 2
    */
void ctp8 (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* edited: ereehuis */
{
    double g;
    double theta, a, b, c, d, e;
    double exp1, exp2;
    g = 1.0 + xreal[1];
    obj[0] = xreal[0];
    obj[1] = g*(1.0  - sqrt(obj[0]/g));
    theta = 0.1*PI;
    a = 40.0;
    b = 0.5;
    c = 1.0;
    d = 2.0;
    e = -2.0;
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[0] = exp1/exp2 - 1.0;
    theta = -0.05*PI;
    a = 40.0;
    b = 2.0;
    c = 1.0;
    d = 6.0;
    e = 0.0;
    exp1 = (obj[1]-e)*cos(theta) - obj[0]*sin(theta);
    exp2 = (obj[1]-e)*sin(theta) + obj[0]*cos(theta);
    exp2 = b*PI*pow(exp2,c);
    exp2 = fabs(sin(exp2));
    exp2 = a*pow(exp2,d);
    constr[1] = exp1/exp2 - 1.0;
    return;
}
#ifdef CTP8
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &ctp8; /* inserted: ereehuis */
#endif

/*  Test problem EMM
    # of real variables = nreal
    # of bin variables = nbin
    # of nominal variables = nnom
    # of objectives = 2
    # of constraints = 0
    */
void emm (double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) /* inserted: ereehuis */
{
    int i;
    double f1 = 0,
	   f2 = 0;

    /* f1: modified step function (see Mixed-Integer Evolution Strategy by Emmerich, 2000) */
    for (i = 0; i < nreal; i++)
        f1 += pow(floor(xreal[i]), 2);

    for (i = 0; i < nbin; i++)
        f1 += pow((double) ((int) ((int) xbin[i] / 10)), 2); /* Discard real part of xbin vars */

    for (i = 0; i < nnom; i++)
        f1 += pow((double) (xnom[i] % 2), 2);

    /* f2: weighted sphere function (see Mixed-Integer Evolution Strategy by Emmerich) */
    for (i = 0; i < nreal; i++)
        f2 += (i+1) * pow(xreal[i], 2);

    for (i = 0; i < nbin; i++)
        f2 += (i+1) * pow((double) ((int) xbin[i]), 2); /* Discard real part of xbin vars */

    for (i = 0; i < nnom; i++)
        f2 += (i+1) * pow((double) xnom[i], 2);

    obj[0] = f1;
    obj[1] = f2;

    return;
}
#ifdef EMM
void (*test_problem)(double *xreal, double *xbin, int **gene, int *xnom, double *obj, double *constr) = &emm; /* inserted: ereehuis */
#endif
